
local function on_built_entity (event)
  local ent = event.created_entity
  local fromstack = event.stack
  local fluid_name = nil
  -- recipe is just to shorten the variable
  local recipe_fluid = nil
  local inserted = nil
  local build_inventory = nil

  --log("on built entity")
  -- subgroup is optional for prototypes
  --if game.item_prototypes[fromstack.name].subgroup then log("subgroup name: "..game.item_prototypes[fromstack.name].subgroup.name) else log("no subgroup") end
  if ent.name == "storage-tank" and game.item_prototypes[fromstack.name].subgroup and game.item_prototypes[fromstack.name].subgroup.name == "fill-storage-tank" then
    --log("built storage tank")
    fluid_name = string.match(fromstack.name, "^(.+)%-storage%-tank$")
    --if fluid_name then log("fluid_name: "..fluid_name) else log("unable to decipher fluid name from item stack") end
    if fluid_name and game.fluid_prototypes[fluid_name] then
      recipe_fluid = game.recipe_prototypes["fill-"..fromstack.name].ingredients[2]
      inserted = ent.insert_fluid({name = fluid_name, amount = recipe_fluid.amount, temperature = recipe_fluid.temperature})
      if inserted == 0 then
        --log("inserted was 0")
        if event.player_index and game.players[event.player_index] and game.players[event.player_index].can_insert({name=fluid_name.."-storage-tank", count = 1}) then
          game.players[event.player_index].insert({name=fluid_name.."-storage-tank", count = 1})
          game.players[event.player_index].create_local_flying_text{text={"action-leads-to-fluid-mixing"}, position = ent.position}
        end

        if event.robot and event.robot.can_insert({name=fluid_name.."-storage-tank", count = 1}) then
         event.robot.insert({name=fluid_name.."-storage-tank", count = 1})
        end

        ent.destroy()
      end
    end
  end
end

local function on_mined_entity (event)
  local ent = event.entity
  local buffer_inventory = event.buffer
  local i = 1
  local fluid = nil
  local recipe_fluid = nil

  if ent.name == "storage-tank" then
    fluid = ent.fluidbox[1]
    if fluid and game.item_prototypes[fluid.name.."-storage-tank"] then
      -- not checking nil because fill recipe and fill item are done together - not future safe
      recipe_fluid = game.recipe_prototypes["fill-"..fluid.name.."-storage-tank"].ingredients[2]

      if fluid.amount >= recipe_fluid.amount-100 then
        -- there might be some edge cases of backflowing... I don't know
        ent.remove_fluid({name = fluid.name, amount = recipe_fluid.amount})
        for i=1,#buffer_inventory do
          if buffer_inventory[i].name == "storage-tank" then
            buffer_inventory.remove({name = "storage-tank", amount = 1})
            buffer_inventory.insert({name = fluid.name.."-storage-tank", count = 1})
            break
          end
        end
      end
    end
  end
end



script.on_event(defines.events.on_built_entity, on_built_entity)
script.on_event(defines.events.on_robot_built_entity, on_built_entity)


script.on_event(defines.events.on_player_mined_entity, on_mined_entity)
script.on_event(defines.events.on_robot_mined_entity, on_mined_entity)