if not data.raw.item["storage-tank"] or not data.raw["storage-tank"] then return end

local uppath = (...):match("(.-)[^%.]+$")
local base = require (uppath.."storage-tank-base")


local fluids = data.raw.fluid
local fluid = nil


for fluid_name, fluid in pairs(fluids) do
  local item = nil
  --log("Working on fluid: "..fluid_name .."\n"..serpent.block(fluid))

  if fluid.auto_barrel == true or fluid.auto_barrel == nil then
--[[
################################# ITEM BEGIN #############################
--]]
    item = table_copy_no_references(base.item)
    if fluid.base_color then
      if fluid.base_color.b then
		item.icons[1].tint = {
		  b = (item.icons[1].tint.b + fluid.base_color.b) / 2,
		  g = (item.icons[1].tint.g + fluid.base_color.g) / 2,
		  r = (item.icons[1].tint.r + fluid.base_color.r) / 2,
		}
      else
		item.icons[1].tint = {
		  b = (item.icons[1].tint.b + fluid.base_color[1]) / 2,
		  g = (item.icons[1].tint.g + fluid.base_color[2]) / 2,
		  r = (item.icons[1].tint.r + fluid.base_color[3]) / 2,
		}
      end
    end
    item.name = fluid_name.."-storage-tank"
--[[
    if data.raw.item[fluid_name.."-barrel"]
        and data.raw.item[fluid_name.."-barrel"].localised_name
        and data.raw.item[fluid_name.."-barrel"].localised_name[2]
        and data.raw.item[fluid_name.."-barrel"].localised_name[2][1]
      then
--]]
    if dig(data.raw.item, fluid_name.."-barrel.localised_name[2][1]") then
      item.localised_name[2][1] = data.raw.item[fluid_name.."-barrel"].localised_name[2][1]
	elseif fluid.localised_name then
      item.localised_name[2][1] = "fluid-name."..fluid_name
    else
      item.localised_name[2][1] = fluid_name
    end

    --log("item localisation: "..serpent.block(item.localised_name))    
    item.order = "ba["..fluid_name.."-storage-tank]"

--[[
################################# ITEM END #############################
--]]


--[[
################################# FILL RECIPE BEGIN #############################
--]]
    local recipe_fill = table_copy_no_references(base.recipe_fill)

    recipe_fill.icons[2].icon = fluid.icon
    if not recipe_fill.icons[2].icon then
      -- yeah I'm not sure what to do in this case
      recipe_fill.icons[2].icon = fluid.icons[1].icon
    end

    recipe_fill.icons[2].icon_size = fluid.icon_size
    if not recipe_fill.icons[2].icon_size then
      recipe_fill.icons[2].icon_size = fluid.icons[1].icon_size
    end
    if recipe_fill.icons[2].icon_size then
      recipe_fill.icons[2].scale = 16 / recipe_fill.icons[2].icon_size
    end

    recipe_fill.ingredients[1].name = fluid_name

    if item.localised_name and item.localised_name[2][1] then
      recipe_fill.localised_name[2][1] = item.localised_name[2][1]
    else
      recipe_fill.localised_name[2][1] = fluid_name
    end
    --log("item localisation: "..serpent.block(recipe_fill.localised_name))

    recipe_fill.name = "fill-"..fluid_name.."-storage-tank"
    recipe_fill.order = "ba["..recipe_fill.name.."]"
    recipe_fill.results[1].name = item.name

--[[
################################# FILL RECIPE END #############################
--]]

--[[
################################# EMPTY RECIPE BEGIN #############################
--]]

    local recipe_empty = table_copy_no_references(base.recipe_empty)
    recipe_empty.icons[2].icon = fluid.icon
    if not recipe_empty.icons[2].icon then
      -- yeah I'm not sure what to do in this case
      recipe_empty.icons[2].icon = fluid.icons[1].icon
    end

    recipe_empty.icons[2].icon_size = fluid.icon_size
    if not recipe_empty.icons[2].icon_size then
      recipe_empty.icons[2].icon_size = fluid.icons[1].icon_size
    end
    if recipe_empty.icons[2].icon_size then
      recipe_empty.icons[2].scale = 16 / recipe_fill.icons[2].icon_size
    end

    recipe_empty.ingredients[1].name = item.name
    recipe_empty.name = "empty-"..item.name
    recipe_empty.localised_name[2][1] = item.localised_name[2][1]
    recipe_empty.results[1].name = fluid_name

--[[
################################# EMPTY RECIPE END #############################
--]]
    if not data.raw["item-subgroup"]["fill-storage-tank"] then
      local subgroup = {
        group = "intermediate-products",
        name = "fill-storage-tank",
        order = "da",
        type = "item-subgroup"
      }
      data.raw["item-subgroup"][subgroup.name] = subgroup
    end

    if not data.raw["item-subgroup"]["empty-storage-tank"] then
      local subgroup = {
        group = "intermediate-products",
        name = "empty-storage-tank",
        order = "ea",
        type = "item-subgroup"
      }
      data.raw["item-subgroup"][subgroup.name] = subgroup
    end

    data.raw.item[item.name] = item
    data.raw.recipe[recipe_fill.name] = recipe_fill
    data.raw.recipe[recipe_empty.name] = recipe_empty

    local fluidtech = data.raw.technology["fluid-handling"]
    if fluidtech then
      if not fluidtech.effects then fluidtech.effects = {} end
      table.insert(fluidtech.effects, {recipe = recipe_fill.name, type = "unlock-recipe"})
      table.insert(fluidtech.effects, {recipe = recipe_empty.name, type = "unlock-recipe"})
    else
      recipe_fill.enabled = true
      recipe_empty.enabled = true
    end
  end
end