--[[
############## FLUID REFERENCE BEGIN ###############
--]]

    water = {
      base_color = {
        b = 0.6,
        g = 0.34000000000000004,
        r = 0
      },
      default_temperature = 15,
      flow_color = {
        b = 0.7,
        g = 0.7,
        r = 0.7
      },
      heat_capacity = "0.2KJ",
      icon = "__base__/graphics/icons/fluid/water.png",
      icon_size = 32,
      max_temperature = 100,
      name = "water",
      order = "a[fluid]-a[water]",
      type = "fluid"
    },

--[[
############## FLUID REFERENCE END ###############
--]]

--[[
############## ITEM REFERENCE BEGIN ###############
--]]

    ["storage-tank"] = {
      icon = "__base__/graphics/icons/storage-tank.png",
      icon_size = 32,
      name = "storage-tank",
      order = "b[fluid]-a[storage-tank]",
      place_result = "storage-tank",
      stack_size = 50,
      subgroup = "storage",
      type = "item"
    },

    ["water-barrel"] = {
      icon_size = 32,
      icons = {
        {
          icon = "__base__/graphics/icons/fluid/barreling/empty-barrel.png"
        },
        {
          icon = "__base__/graphics/icons/fluid/barreling/barrel-side-mask.png",
          tint = {
            a = 0.75,
            b = 0.6,
            g = 0.34000000000000004,
            r = 0
          }
        },
        {
          icon = "__base__/graphics/icons/fluid/barreling/barrel-hoop-top-mask.png",
          tint = {
            a = 0.75,
            b = 0.7,
            g = 0.7,
            r = 0.7
          }
        }
      },
      localised_name = {
        "item-name.filled-barrel",
        {
          "fluid-name.water"
        }
      },
      name = "water-barrel",
      order = "b[water-barrel]",
      stack_size = 10,
      subgroup = "fill-barrel",
      type = "item"
    },

--[[
############## ITEM REFERENCE END ###############
--]]

--[[
############## RECIPE REFERENCE BEGIN ###############
--]]

    ["fill-water-barrel"] = {
      allow_decomposition = false,
      category = "crafting-with-fluid",
      enabled = false,
      energy_required = 0.2,
      icon_size = 32,
      icons = {
        {
          icon = "__base__/graphics/icons/fluid/barreling/barrel-fill.png",
          icon_size = 32
        },
        {
          icon = "__base__/graphics/icons/fluid/barreling/barrel-fill-side-mask.png",
          icon_size = 32,
          tint = {
            a = 0.75,
            b = 0.6,
            g = 0.34000000000000004,
            r = 0
          }
        },
        {
          icon = "__base__/graphics/icons/fluid/barreling/barrel-fill-top-mask.png",
          icon_size = 32,
          tint = {
            a = 0.75,
            b = 0.7,
            g = 0.7,
            r = 0.7
          }
        },
        {
          icon = "__base__/graphics/icons/fluid/water.png",
          icon_size = 32,
          scale = 0.5,
          shift = {
            4,
            -8
          }
        }
      },
      ingredients = {
        {
          amount = 50,
          catalyst_amount = 50,
          name = "water",
          type = "fluid"
        },
        {
          amount = 1,
          catalyst_amount = 1,
          name = "empty-barrel",
          type = "item"
        }
      },
      localised_name = {
        "recipe-name.fill-barrel",
        {
          "fluid-name.water"
        }
      },
      name = "fill-water-barrel",
      order = "b[fill-water-barrel]",
      results = {
        {
          amount = 1,
          catalyst_amount = 1,
          name = "water-barrel",
          type = "item"
        }
      },
      subgroup = "fill-barrel",
      type = "recipe"
    },



    ["empty-water-barrel"] = {
      allow_decomposition = false,
      category = "crafting-with-fluid",
      enabled = false,
      energy_required = 0.2,
      icon_size = 32,
      icons = {
        {
          icon = "__base__/graphics/icons/fluid/barreling/barrel-empty.png",
          icon_size = 32
        },
        {
          icon = "__base__/graphics/icons/fluid/barreling/barrel-empty-side-mask.png",
          icon_size = 32,
          tint = {
            a = 0.75,
            b = 0.6,
            g = 0.34000000000000004,
            r = 0
          }
        },
        {
          icon = "__base__/graphics/icons/fluid/barreling/barrel-empty-top-mask.png",
          icon_size = 32,
          tint = {
            a = 0.75,
            b = 0.7,
            g = 0.7,
            r = 0.7
          }
        },
        {
          icon = "__base__/graphics/icons/fluid/water.png",
          icon_size = 32,
          scale = 0.5,
          shift = {
            7,
            8
          }
        }
      },
      ingredients = {
        {
          amount = 1,
          catalyst_amount = 1,
          name = "water-barrel",
          type = "item"
        }
      },
      localised_name = {
        "recipe-name.empty-filled-barrel",
        {
          "fluid-name.water"
        }
      },
      name = "empty-water-barrel",
      order = "c[empty-water-barrel]",
      results = {
        {
          amount = 50,
          catalyst_amount = 50,
          name = "water",
          type = "fluid"
        },
        {
          amount = 1,
          catalyst_amount = 1,
          name = "empty-barrel",
          type = "item"
        }
      },
      subgroup = "empty-barrel",
      type = "recipe"
    },


--[[
############## RECIPE REFERENCE END ###############
--]]