function dig(intable, digfor)
  --recurses a table until it finds a final table/value and returns it
  --returns nil if it can't find it or has an error (i.e. trying to access the sub-element of a number

  --digfor is of the form {key = {key2 = {key3}}}, or a number (anonymous table/value/index), or a string which can be one[2].three
  --doesn't check if the final value is a table or not. Or even nil. That's up to something else to decide what it means

  --I don't want to modify the existing digging path or digging criteria

  local sequence = nil
  local key = nil

  if (type(intable) ~= "table") or (digfor == nil) then return nil end

  sequence = intable

  if type(digfor) == "table" then
    sequence = intable
    --key = next(digfor, nil)
    while (type(sequence) ~= "string") and (type(sequence) ~= "number") do
      if type(sequence) == "table" then
        key = next(sequence,nil)
        sequence = sequence[key]
      elseif type(sequence) == "string" or (type(sequence) == "number") then
        return sequence
      else
        --there's a bool or something, which isn't a valid path key
        return nil
      end
    end
    return sequence
  elseif type(digfor) == "string" then
    while digfor ~= "" and sequence ~= nil do
      --a little overzealous with the cleaning... thought someday I would do dig(table, ".thing.thing2" <--- the leading period would break things if not ignored
      --log("digfor: " .. digfor)
      key = string.match(digfor, "^%.?%[?([%w_%-;%s]+)%]?%.?")
      if key == nil then
        log("dig(): unexpected characters in fake path handling, returning early")
        return nil --in case we didn't capture anything
      end
      --log("key: " .. key)
      --log("digfor before: " .. digfor)
      digfor = string.gsub(digfor, "^%.?%[?[%w_%-;%s]+%]?%.?", "") --if I use key in the string to catch, I risk having unescaped -'s sneak in
      --log("digfor after: " .. digfor)
      if string.match(key, "^%d+$") then
        --this has the side effect that table.1.2 , table[1][2] , and table["1"]["2"] mean the same thing - array access
        --cannot dig for a string that is a number as a result, which was probably done by a careless programmer anyway
        --log("converting number to array index")
        key = tonumber(key)
      end
      --log("Before changing sequence")
      --DumpEverything(sequence)
      sequence = sequence[key]
      --log("After Changing sequence")
      --DumpEverything(sequence)      
    end
    return sequence
  elseif type(digfor) == "number" then
    --do this now in case I do something stupid like pass a number as an array index
    return intable[digfor]
  else
    log("Error while digging for path. What we need for digging is a properly formatted table or string, or a single number")
    return nil
  end
  --can't reach here
end
